/*
 * SCPI command tree
 * 
 */
 
#include "Arduino.h"
#include "scpiparser.h"
#include "scpi_user.h"
#include "cmd_tree.h"

// command strings

const char l_sys[]     PROGMEM = "SYSTEM";    // long form
const char s_sys[]     PROGMEM = "SYS";       // short form
const char l_error1[]  PROGMEM = "ERROR";
const char s_error1[]  PROGMEM = "ERR";
const char l_error2[]  PROGMEM = "ERROR?";
const char s_error2[]  PROGMEM = "ERR?";
const char l_next[]    PROGMEM = "NEXT?";
const char l_idn[]     PROGMEM = "*IDN?";
const char l_rst[]     PROGMEM = "*RST";
const char l_cls[]     PROGMEM = "*CLS";
const char l_digital[] PROGMEM = "DIGITAL";
const char s_digital[] PROGMEM = "DIG";

const char l_s1[] PROGMEM = "SWITCH1";
const char s_s1[] PROGMEM = "SW1";
const char l_s2[] PROGMEM = "SWITCH2";
const char s_s2[] PROGMEM = "SW2";
const char l_s3[] PROGMEM = "SWITCH3";
const char s_s3[] PROGMEM = "SW3";
const char l_s4[] PROGMEM = "SWITCH4";
const char s_s4[] PROGMEM = "SW4";
const char l_s5[] PROGMEM = "SWITCH5";
const char s_s5[] PROGMEM = "SW5";
const char l_s6[] PROGMEM = "SWITCH6";
const char s_s6[] PROGMEM = "SW6";
const char l_s7[] PROGMEM = "SWITCH7";
const char s_s7[] PROGMEM = "SW7";
const char l_s8[] PROGMEM = "SWITCH8";
const char s_s8[] PROGMEM = "SW8";
const char l_s9[] PROGMEM = "SWITCH9";
const char s_s9[] PROGMEM = "SW9";
const char l_s10[] PROGMEM = "SWITCH10";
const char s_s10[] PROGMEM = "SW10";
const char l_s11[] PROGMEM = "SWITCH11";
const char s_s11[] PROGMEM = "SW11";
const char l_s12[] PROGMEM = "SWITCH12";
const char s_s12[] PROGMEM = "SW12";
const char l_s13[] PROGMEM = "SWITCH13";
const char s_s13[] PROGMEM = "SW13";
const char l_s14[] PROGMEM = "SWITCH14";
const char s_s14[] PROGMEM = "SW14";
const char l_s15[] PROGMEM = "SWITCH15";
const char s_s15[] PROGMEM = "SW15";
const char l_s16[] PROGMEM = "SWITCH16";
const char s_s16[] PROGMEM = "SW16";
const char l_s17[] PROGMEM = "SWITCH17";
const char s_s17[] PROGMEM = "SW17";
const char l_s18[] PROGMEM = "SWITCH18";
const char s_s18[] PROGMEM = "SW18";
const char l_s19[] PROGMEM = "SWITCH19";
const char s_s19[] PROGMEM = "SW19";
const char l_s20[] PROGMEM = "SWITCH20";
const char s_s20[] PROGMEM = "SW20";
const char l_s21[] PROGMEM = "SWITCH21";
const char s_s21[] PROGMEM = "SW21";
const char l_s22[] PROGMEM = "SWITCH22";
const char s_s22[] PROGMEM = "SW22";
const char l_s23[] PROGMEM = "SWITCH23";
const char s_s23[] PROGMEM = "SW23";
const char l_s24[] PROGMEM = "SWITCH24";
const char s_s24[] PROGMEM = "SW24";
const char l_s25[] PROGMEM = "SWITCH25";
const char s_s25[] PROGMEM = "SW25";
const char l_s26[] PROGMEM = "SWITCH26";
const char s_s26[] PROGMEM = "SW26";
const char l_s27[] PROGMEM = "SWITCH27";
const char s_s27[] PROGMEM = "SW27";
const char l_s28[] PROGMEM = "SWITCH28";
const char s_s28[] PROGMEM = "SW28";
const char l_s29[] PROGMEM = "SWITCH29";
const char s_s29[] PROGMEM = "SW29";
const char l_s30[] PROGMEM = "SWITCH30";
const char s_s30[] PROGMEM = "SW30";
const char l_s31[] PROGMEM = "SWITCH31";
const char s_s31[] PROGMEM = "SW31";
const char l_s32[] PROGMEM = "SWITCH32";
const char s_s32[] PROGMEM = "SW32";

const char l_sq1[] PROGMEM = "SWITCH1?";
const char s_sq1[] PROGMEM = "SW1?";
const char l_sq2[] PROGMEM = "SWITCH2?";
const char s_sq2[] PROGMEM = "SW2?";
const char l_sq3[] PROGMEM = "SWITCH3?";
const char s_sq3[] PROGMEM = "SW3?";
const char l_sq4[] PROGMEM = "SWITCH4?";
const char s_sq4[] PROGMEM = "SW4?";
const char l_sq5[] PROGMEM = "SWITCH5?";
const char s_sq5[] PROGMEM = "SW5?";
const char l_sq6[] PROGMEM = "SWITCH6?";
const char s_sq6[] PROGMEM = "SW6?";
const char l_sq7[] PROGMEM = "SWITCH7?";
const char s_sq7[] PROGMEM = "SW7?";
const char l_sq8[] PROGMEM = "SWITCH8?";
const char s_sq8[] PROGMEM = "SW8?";
const char l_sq9[] PROGMEM = "SWITCH9?";
const char s_sq9[] PROGMEM = "SW9?";
const char l_sq10[] PROGMEM = "SWITCH10?";
const char s_sq10[] PROGMEM = "SW10?";
const char l_sq11[] PROGMEM = "SWITCH11?";
const char s_sq11[] PROGMEM = "SW11?";
const char l_sq12[] PROGMEM = "SWITCH12?";
const char s_sq12[] PROGMEM = "SW12?";
const char l_sq13[] PROGMEM = "SWITCH13?";
const char s_sq13[] PROGMEM = "SW13?";
const char l_sq14[] PROGMEM = "SWITCH14?";
const char s_sq14[] PROGMEM = "SW14?";
const char l_sq15[] PROGMEM = "SWITCH15?";
const char s_sq15[] PROGMEM = "SW15?";
const char l_sq16[] PROGMEM = "SWITCH16?";
const char s_sq16[] PROGMEM = "SW16?";
const char l_sq17[] PROGMEM = "SWITCH17?";
const char s_sq17[] PROGMEM = "SW17?";
const char l_sq18[] PROGMEM = "SWITCH18?";
const char s_sq18[] PROGMEM = "SW18?";
const char l_sq19[] PROGMEM = "SWITCH19?";
const char s_sq19[] PROGMEM = "SW19?";
const char l_sq20[] PROGMEM = "SWITCH20?";
const char s_sq20[] PROGMEM = "SW20?";
const char l_sq21[] PROGMEM = "SWITCH21?";
const char s_sq21[] PROGMEM = "SW21?";
const char l_sq22[] PROGMEM = "SWITCH22?";
const char s_sq22[] PROGMEM = "SW22?";
const char l_sq23[] PROGMEM = "SWITCH23?";
const char s_sq23[] PROGMEM = "SW23?";
const char l_sq24[] PROGMEM = "SWITCH24?";
const char s_sq24[] PROGMEM = "SW24?";
const char l_sq25[] PROGMEM = "SWITCH25?";
const char s_sq25[] PROGMEM = "SW25?";
const char l_sq26[] PROGMEM = "SWITCH26?";
const char s_sq26[] PROGMEM = "SW26?";
const char l_sq27[] PROGMEM = "SWITCH27?";
const char s_sq27[] PROGMEM = "SW27?";
const char l_sq28[] PROGMEM = "SWITCH28?";
const char s_sq28[] PROGMEM = "SW28?";
const char l_sq29[] PROGMEM = "SWITCH29?";
const char s_sq29[] PROGMEM = "SW29?";
const char l_sq30[] PROGMEM = "SWITCH30?";
const char s_sq30[] PROGMEM = "SW30?";
const char l_sq31[] PROGMEM = "SWITCH31?";
const char s_sq31[] PROGMEM = "SW31?";
const char l_sq32[] PROGMEM = "SWITCH32?";
const char s_sq32[] PROGMEM = "SW32?";

// SCPI system commands
// all pointers to                              long  short name
//                                                          next      children     callback                       
const struct scpi_command       root PROGMEM = {NULL, NULL, &idn_cmd, &system_cmd, NULL};
const struct scpi_command system_cmd PROGMEM = {l_sys, s_sys, &digital_cmd, &error1_cmd, NULL};
const struct scpi_command error1_cmd PROGMEM = {l_error1, s_error1, &error2_cmd, &next_cmd, NULL};
const struct scpi_command error2_cmd PROGMEM = {l_error2, s_error2, NULL, NULL, system_error};
const struct scpi_command   next_cmd PROGMEM = {l_next, l_next, NULL, NULL, system_error};

// SCPI user commands

const struct scpi_command     idn_cmd PROGMEM = {l_idn, l_idn, &rst_cmd, NULL, identify};
const struct scpi_command     rst_cmd PROGMEM = {l_rst, l_rst, &cls_cmd, NULL, reset};
const struct scpi_command     cls_cmd PROGMEM = {l_cls, l_cls, NULL, NULL, reset};
const struct scpi_command digital_cmd PROGMEM = {l_digital, s_digital, NULL, &s1_cmd, NULL};

const struct scpi_command      s1_cmd PROGMEM = {l_s1, s_s1, &s2_cmd, NULL, set_digital_1};
const struct scpi_command      s2_cmd PROGMEM = {l_s2, s_s2, &s3_cmd, NULL, set_digital_2};
const struct scpi_command      s3_cmd PROGMEM = {l_s3, s_s3, &s4_cmd, NULL, set_digital_3};
const struct scpi_command      s4_cmd PROGMEM = {l_s4, s_s4, &s5_cmd, NULL, set_digital_4};
const struct scpi_command      s5_cmd PROGMEM = {l_s5, s_s5, &s6_cmd, NULL, set_digital_5};
const struct scpi_command      s6_cmd PROGMEM = {l_s6, s_s6, &s7_cmd, NULL, set_digital_6};
const struct scpi_command      s7_cmd PROGMEM = {l_s7, s_s7, &s8_cmd, NULL, set_digital_7};
const struct scpi_command      s8_cmd PROGMEM = {l_s8, s_s8, &s9_cmd, NULL, set_digital_8};
const struct scpi_command      s9_cmd PROGMEM = {l_s9, s_s9, &s10_cmd, NULL, set_digital_9};
const struct scpi_command      s10_cmd PROGMEM = {l_s10, s_s10, &s11_cmd, NULL, set_digital_10};
const struct scpi_command      s11_cmd PROGMEM = {l_s11, s_s11, &s12_cmd, NULL, set_digital_11};
const struct scpi_command      s12_cmd PROGMEM = {l_s12, s_s12, &s13_cmd, NULL, set_digital_12};
const struct scpi_command      s13_cmd PROGMEM = {l_s13, s_s13, &s14_cmd, NULL, set_digital_13};
const struct scpi_command      s14_cmd PROGMEM = {l_s14, s_s14, &s15_cmd, NULL, set_digital_14};
const struct scpi_command      s15_cmd PROGMEM = {l_s15, s_s15, &s16_cmd, NULL, set_digital_15};
const struct scpi_command      s16_cmd PROGMEM = {l_s16, s_s16, &s17_cmd, NULL, set_digital_16};
const struct scpi_command      s17_cmd PROGMEM = {l_s17, s_s17, &s18_cmd, NULL, set_digital_17};
const struct scpi_command      s18_cmd PROGMEM = {l_s18, s_s18, &s19_cmd, NULL, set_digital_18};
const struct scpi_command      s19_cmd PROGMEM = {l_s19, s_s19, &s20_cmd, NULL, set_digital_19};
const struct scpi_command      s20_cmd PROGMEM = {l_s20, s_s20, &s21_cmd, NULL, set_digital_20};
const struct scpi_command      s21_cmd PROGMEM = {l_s21, s_s21, &s22_cmd, NULL, set_digital_21};
const struct scpi_command      s22_cmd PROGMEM = {l_s22, s_s22, &s23_cmd, NULL, set_digital_22};
const struct scpi_command      s23_cmd PROGMEM = {l_s23, s_s23, &s24_cmd, NULL, set_digital_23};
const struct scpi_command      s24_cmd PROGMEM = {l_s24, s_s24, &s25_cmd, NULL, set_digital_24};
const struct scpi_command      s25_cmd PROGMEM = {l_s25, s_s25, &s26_cmd, NULL, set_digital_25};
const struct scpi_command      s26_cmd PROGMEM = {l_s26, s_s26, &s27_cmd, NULL, set_digital_26};
const struct scpi_command      s27_cmd PROGMEM = {l_s27, s_s27, &s28_cmd, NULL, set_digital_27};
const struct scpi_command      s28_cmd PROGMEM = {l_s28, s_s28, &s29_cmd, NULL, set_digital_28};
const struct scpi_command      s29_cmd PROGMEM = {l_s29, s_s29, &s30_cmd, NULL, set_digital_29};
const struct scpi_command      s30_cmd PROGMEM = {l_s30, s_s30, &s31_cmd, NULL, set_digital_30};
const struct scpi_command      s31_cmd PROGMEM = {l_s31, s_s31, &s32_cmd, NULL, set_digital_31};
const struct scpi_command      s32_cmd PROGMEM = {l_s32, s_s32, &sq1_cmd, NULL, set_digital_32};

const struct scpi_command      sq1_cmd PROGMEM = {l_sq1, s_sq1, &sq2_cmd, NULL, get_digital_1};
const struct scpi_command      sq2_cmd PROGMEM = {l_sq2, s_sq2, &sq3_cmd, NULL, get_digital_2};
const struct scpi_command      sq3_cmd PROGMEM = {l_sq3, s_sq3, &sq4_cmd, NULL, get_digital_3};
const struct scpi_command      sq4_cmd PROGMEM = {l_sq4, s_sq4, &sq5_cmd, NULL, get_digital_4};
const struct scpi_command      sq5_cmd PROGMEM = {l_sq5, s_sq5, &sq6_cmd, NULL, get_digital_5};
const struct scpi_command      sq6_cmd PROGMEM = {l_sq6, s_sq6, &sq7_cmd, NULL, get_digital_6};
const struct scpi_command      sq7_cmd PROGMEM = {l_sq7, s_sq7, &sq8_cmd, NULL, get_digital_7};
const struct scpi_command      sq8_cmd PROGMEM = {l_sq8, s_sq8, &sq9_cmd, NULL, get_digital_8};
const struct scpi_command      sq9_cmd PROGMEM = {l_sq9, s_sq9, &sq10_cmd, NULL, get_digital_9};
const struct scpi_command      sq10_cmd PROGMEM = {l_sq10, s_sq10, &sq11_cmd, NULL, get_digital_10};
const struct scpi_command      sq11_cmd PROGMEM = {l_sq11, s_sq11, &sq12_cmd, NULL, get_digital_11};
const struct scpi_command      sq12_cmd PROGMEM = {l_sq12, s_sq12, &sq13_cmd, NULL, get_digital_12};
const struct scpi_command      sq13_cmd PROGMEM = {l_sq13, s_sq13, &sq14_cmd, NULL, get_digital_13};
const struct scpi_command      sq14_cmd PROGMEM = {l_sq14, s_sq14, &sq15_cmd, NULL, get_digital_14};
const struct scpi_command      sq15_cmd PROGMEM = {l_sq15, s_sq15, &sq16_cmd, NULL, get_digital_15};
const struct scpi_command      sq16_cmd PROGMEM = {l_sq16, s_sq16, &sq17_cmd, NULL, get_digital_16};
const struct scpi_command      sq17_cmd PROGMEM = {l_sq17, s_sq17, &sq18_cmd, NULL, get_digital_17};
const struct scpi_command      sq18_cmd PROGMEM = {l_sq18, s_sq18, &sq19_cmd, NULL, get_digital_18};
const struct scpi_command      sq19_cmd PROGMEM = {l_sq19, s_sq19, &sq20_cmd, NULL, get_digital_19};
const struct scpi_command      sq20_cmd PROGMEM = {l_sq20, s_sq20, &sq21_cmd, NULL, get_digital_20};
const struct scpi_command      sq21_cmd PROGMEM = {l_sq21, s_sq21, &sq22_cmd, NULL, get_digital_21};
const struct scpi_command      sq22_cmd PROGMEM = {l_sq22, s_sq22, &sq23_cmd, NULL, get_digital_22};
const struct scpi_command      sq23_cmd PROGMEM = {l_sq23, s_sq23, &sq24_cmd, NULL, get_digital_23};
const struct scpi_command      sq24_cmd PROGMEM = {l_sq24, s_sq24, &sq25_cmd, NULL, get_digital_24};
const struct scpi_command      sq25_cmd PROGMEM = {l_sq25, s_sq25, &sq26_cmd, NULL, get_digital_25};
const struct scpi_command      sq26_cmd PROGMEM = {l_sq26, s_sq26, &sq27_cmd, NULL, get_digital_26};
const struct scpi_command      sq27_cmd PROGMEM = {l_sq27, s_sq27, &sq28_cmd, NULL, get_digital_27};
const struct scpi_command      sq28_cmd PROGMEM = {l_sq28, s_sq28, &sq29_cmd, NULL, get_digital_28};
const struct scpi_command      sq29_cmd PROGMEM = {l_sq29, s_sq29, &sq30_cmd, NULL, get_digital_29};
const struct scpi_command      sq30_cmd PROGMEM = {l_sq30, s_sq30, &sq31_cmd, NULL, get_digital_30};
const struct scpi_command      sq31_cmd PROGMEM = {l_sq31, s_sq31, &sq32_cmd, NULL, get_digital_31};
const struct scpi_command      sq32_cmd PROGMEM = {l_sq32, s_sq32,      NULL, NULL, get_digital_32};



 
