#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <Arduino.h>
#include "scpiparser.h"
#include "test.h"

void dump_command(struct scpi_command* command) {
  char str[30];
  
  if (command != NULL) {
    Serial.println(F("CMD dump"));
    strcpy_P(str, pgm_read_word(&command->long_name));
    Serial.println(str);
    strcpy_P(str, pgm_read_word(&command->short_name));
    Serial.println(str);
    Serial.print(F("next     : ")); Serial.println((unsigned int)pgm_read_word(&command->next));
    Serial.print(F("children : ")); Serial.println((unsigned int)pgm_read_word(&command->children));
    Serial.print(F("callback : ")); Serial.println((unsigned int)pgm_read_word(&command->callback));
  } else {
    Serial.println(F("Command NULL")); 
  }
}

void dump_cmd_string(char * str) {
  int i;

  Serial.println(F("CMD string"));
  for(i=0; i<100; i++, str++) {
    if (*str == 0) {
      Serial.print('/');
    } else if (*str < 0x20) {
      Serial.print('%'); 
    } else {
      Serial.print(*str);
    }
  }
  Serial.println();
}

void dump_token_list(const char* token[]) {
  int i;
  
  Serial.println(F("Token list dump"));
  for (i=0; token[i] != NULL; i++) {
    Serial.print(i+1); Serial.print(' ');
    Serial.println(token[i]);
  }
}

void dump_cmd_tree(const struct scpi_command* cmd, int level) {
  int i, j;
  char tmp_str[30];

  if (level == 0) Serial.println(F("Command Tree"));

  for (i=1; cmd != NULL; i++, cmd = pgm_read_word(&cmd->next) ) {
    for (j=2*level; j>0; j--) Serial.print(' ');  
    Serial.print(i); Serial.print(": ");
    if (level == 0 && (void*)pgm_read_word(&cmd->long_name) == NULL) {
      Serial.println(F("root"));
    } else {
      strcpy_P(tmp_str, pgm_read_word(&cmd->long_name));
      Serial.print(tmp_str); Serial.print(' ');
      strcpy_P(tmp_str, pgm_read_word(&cmd->short_name));
      Serial.println(tmp_str);
    }
    if ((void*)pgm_read_word(&cmd->children) != NULL) {
      dump_cmd_tree(pgm_read_word(&cmd->children), level+1);
    }    
  }
}
  
